%global debug_package %{nil}
%define kernel_version %(ver=`rpm -qa|grep kernel-devel`;echo ${ver#*kernel-devel-})

Name         :  dim
Summary      :  Dynamic Integrity Measurement
Version      :  1.0.2
Release      :  5
License      :  GPL-2.0
Source0      :  %{name}-v%{version}.tar.gz
BuildRequires:  kernel-devel kernel-headers
Requires     :  kernel

Patch0001:      Limit-the-max-line-number-of-policy-and-baseline-par.patch
Patch0002:      Use-jiffies64-interface-to-set-measure-interval.patch
Patch0003:      Add-the-owner-of-file-operations.patch
Patch0004:      fix-build-error-in-kernel-6.6.patch
%description
Dynamic Integrity Measurement

%prep
%autosetup -n %{name}-v%{version} -p1

%build
cd src
sed -i 's#/lib/modules/$(shell uname -r)/build#/lib/modules/%{kernel_version}/build#' Makefile
make

%install
mkdir -p $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/extra/dim
install -m 600 ./src/dim_core.ko $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/extra/dim
install -m 600 ./src/dim_monitor.ko $RPM_BUILD_ROOT/lib/modules/%{kernel_version}/extra/dim

%pre

%post
depmod -a `uname -r`

%preun

%postun
depmod -a

%posttrans

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root)
%attr(0400,root,root) /lib/modules/%{kernel_version}/extra/dim/dim_core.ko
%attr(0400,root,root) /lib/modules/%{kernel_version}/extra/dim/dim_monitor.ko

%changelog
* Fri Jan 26 2024 jinlun <jinlun@huawei.com> 1.0.2-5
- The compilation error asused by the kernel upgrade is rectified.

* Mon Sep 18 2023 jinlun <jinlun@huawei.com> 1.0.2-4
- Fix the concurrent issues with removing module and accessing interfaces.

* Fri Sep 15 2023 luhuaxin <luhuaxin1@huawei.com> 1.0.2-3
- Use jiffies64 interface to set measure interval

* Thu Sep 14 2023 luhuaxin <luhuaxin1@huawei.com> 1.0.2-2
- Limit the max line number of policy and baseline parsing

* Mon Sep 4 2023 jinlun <jinlun@huawei.com> 1.0.2-1
- Init package
